Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 502)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 503)
@@ -1305,390 +1890,372 @@
 		info_len += len;
 	}
-	PJ_LOG(3,(THIS_FILE,"Media started%s", info));
-    }
-}
-
-
-/*
- * Hangup call.
- */
-PJ_DEF(void) pjsua_call_hangup(int call_index)
-{
+	PJ_LOG(4,(THIS_FILE,"Media updates%s", info));
+    }
+
+    /* Call application callback, if any */
+    if (pjsua_var.ua_cfg.cb.on_call_media_state)
+	pjsua_var.ua_cfg.cb.on_call_media_state(call->index);
+
+
+    PJSUA_UNLOCK();
+}
+
+
+/*
+ * Create inactive SDP for call hold.
+ */
+static pj_status_t create_inactive_sdp(pjsua_call *call,
+				       pjmedia_sdp_session **p_answer)
+{
+    pj_status_t status;
+    pjmedia_sdp_conn *conn;
+    pjmedia_sdp_attr *attr;
+    pjmedia_sdp_session *sdp;
+
+    /* Create new offer */
+    status = pjmedia_endpt_create_sdp(pjsua_var.med_endpt, pjsua_var.pool, 1,
+				      &call->skinfo, &sdp);
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "Unable to create local SDP", status);
+	return status;
+    }
+
+    /* Get SDP media connection line */
+    conn = sdp->media[0]->conn;
+    if (!conn)
+	conn = sdp->conn;
+
+    /* Modify address */
+    conn->addr = pj_str("0.0.0.0");
+
+    /* Remove existing directions attributes */
+    pjmedia_sdp_media_remove_all_attr(sdp->media[0], "sendrecv");
+    pjmedia_sdp_media_remove_all_attr(sdp->media[0], "sendonly");
+    pjmedia_sdp_media_remove_all_attr(sdp->media[0], "recvonly");
+    pjmedia_sdp_media_remove_all_attr(sdp->media[0], "inactive");
+
+    /* Add inactive attribute */
+    attr = pjmedia_sdp_attr_create(pjsua_var.pool, "inactive", NULL);
+    pjmedia_sdp_media_add_attr(sdp->media[0], attr);
+
+    *p_answer = sdp;
+
+    return status;
+}
+
+
+/*
+ * Called when session received new offer.
+ */
+static void pjsua_call_on_rx_offer(pjsip_inv_session *inv,
+				   const pjmedia_sdp_session *offer)
+{
+    const char *remote_state;
     pjsua_call *call;
-    int code;
+    pjmedia_sdp_conn *conn;
+    pjmedia_sdp_session *answer;
+    pj_bool_t is_remote_active;
+    pj_status_t status;
+
+    PJSUA_LOCK();
+
+    call = inv->dlg->mod_data[pjsua_var.mod.id];
+
+    /*
+     * See if remote is offering active media (i.e. not on-hold)
+     */
+    is_remote_active = PJ_TRUE;
+
+    conn = offer->media[0]->conn;
+    if (!conn)
+	conn = offer->conn;
+
+    if (pj_strcmp2(&conn->addr, "0.0.0.0")==0 ||
+	pj_strcmp2(&conn->addr, "0")==0)
+    {
+	is_remote_active = PJ_FALSE;
+
+    } 
+    else if (pjmedia_sdp_media_find_attr2(offer->media[0], "inactive", NULL))
+    {
+	is_remote_active = PJ_FALSE;
+    }
+
+    remote_state = (is_remote_active ? "active" : "inactive");
+
+    /* Supply candidate answer */
+    if (call->media_st == PJSUA_CALL_MEDIA_LOCAL_HOLD || !is_remote_active) {
+	PJ_LOG(4,(THIS_FILE, 
+		  "Call %d: RX new media offer, creating inactive SDP "
+		  "(media in offer is %s)", call->index, remote_state));
+	status = create_inactive_sdp( call, &answer );
+    } else {
+	PJ_LOG(4,(THIS_FILE, "Call %d: received updated media offer",
+		  call->index));
+	status = pjmedia_endpt_create_sdp( pjsua_var.med_endpt, 
+					   call->inv->pool, 1,
+					   &call->skinfo, &answer);	
+    }
+
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "Unable to create local SDP", status);
+	PJSUA_UNLOCK();
+	return;
+    }
+
+    status = pjsip_inv_set_sdp_answer(call->inv, answer);
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "Unable to set answer", status);
+	PJSUA_UNLOCK();
+	return;
+    }
+
+    PJSUA_UNLOCK();
+}
+
+
+/*
+ * Callback called by event framework when the xfer subscription state
+ * has changed.
+ */
+static void xfer_on_evsub_state( pjsip_evsub *sub, pjsip_event *event)
+{
+    
+    PJ_UNUSED_ARG(event);
+
+    /*
+     * We're only interested when subscription is terminated, to 
+     * clear the xfer_sub member of the inv_data.
+     */
+    if (pjsip_evsub_get_state(sub) == PJSIP_EVSUB_STATE_TERMINATED) {
+	pjsua_call *call;
+
+	call = pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
+	if (!call)
+	    return;
+
+	pjsip_evsub_set_mod_data(sub, pjsua_var.mod.id, NULL);
+	call->xfer_sub = NULL;
+
+	PJ_LOG(3,(THIS_FILE, "Xfer subscription terminated"));
+    }
+}
+
+
+/*
+ * Follow transfer (REFER) request.
+ */
+static void on_call_transfered( pjsip_inv_session *inv,
+			        pjsip_rx_data *rdata )
+{
     pj_status_t status;
     pjsip_tx_data *tdata;
-
-
-    call = &pjsua.calls[call_index];
-
-    if (!call->inv) {
-	PJ_LOG(3,(THIS_FILE,"Call has been disconnected"));
+    pjsua_call *existing_call;
+    int new_call;
+    const pj_str_t str_refer_to = { "Refer-To", 8};
+    pjsip_generic_string_hdr *refer_to;
+    char *uri;
+    pj_str_t tmp;
+    struct pjsip_evsub_user xfer_cb;
+    pjsip_status_code code;
+    pjsip_evsub *sub;
+
+    existing_call = inv->dlg->mod_data[pjsua_var.mod.id];
+
+    /* Find the Refer-To header */
+    refer_to = (pjsip_generic_string_hdr*)
+	pjsip_msg_find_hdr_by_name(rdata->msg_info.msg, &str_refer_to, NULL);
+
+    if (refer_to == NULL) {
+	/* Invalid Request.
+	 * No Refer-To header!
+	 */
+	PJ_LOG(4,(THIS_FILE, "Received REFER without Refer-To header!"));
+	pjsip_dlg_respond( inv->dlg, rdata, 400, NULL, NULL, NULL);
 	return;
     }
 
-    if (call->inv->state == PJSIP_INV_STATE_CONFIRMED)
-	code = PJSIP_SC_OK;
-    else if (call->inv->role == PJSIP_ROLE_UAS)
-	code = PJSIP_SC_DECLINE;
-    else
-	code = PJSIP_SC_REQUEST_TERMINATED;
-
-    status = pjsip_inv_end_session(call->inv, code, NULL, &tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, 
-		     "Failed to create end session message", 
-		     status);
+    /* Notify callback */
+    code = PJSIP_SC_OK;
+    if (pjsua_var.ua_cfg.cb.on_call_transfered)
+	(*pjsua_var.ua_cfg.cb.on_call_transfered)(existing_call->index,
+						  &refer_to->hvalue, &code);
+
+    if (code < 200)
+	code = 200;
+    if (code >= 300) {
+	/* Application rejects call transfer request */
+	pjsip_dlg_respond( inv->dlg, rdata, code, NULL, NULL, NULL);
 	return;
     }
 
-    /* pjsip_inv_end_session may return PJ_SUCCESS with NULL 
-     * as p_tdata when INVITE transaction has not been answered
-     * with any provisional responses.
+    PJ_LOG(3,(THIS_FILE, "Call to %.*s is being transfered to %.*s",
+	      (int)inv->dlg->remote.info_str.slen,
+	      inv->dlg->remote.info_str.ptr,
+	      (int)refer_to->hvalue.slen, 
+	      refer_to->hvalue.ptr));
+
+    /* Init callback */
+    pj_memset(&xfer_cb, 0, sizeof(xfer_cb));
+    xfer_cb.on_evsub_state = &xfer_on_evsub_state;
+
+    /* Create transferee event subscription */
+    status = pjsip_xfer_create_uas( inv->dlg, &xfer_cb, rdata, &sub);
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "Unable to create xfer uas", status);
+	pjsip_dlg_respond( inv->dlg, rdata, 500, NULL, NULL, NULL);
+	return;
+    }
+
+    /* Accept the REFER request, send 200 (OK). */
+    pjsip_xfer_accept(sub, rdata, code, NULL);
+
+    /* Create initial NOTIFY request */
+    status = pjsip_xfer_notify( sub, PJSIP_EVSUB_STATE_ACTIVE,
+				100, NULL, &tdata);
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "Unable to create NOTIFY to REFER", status);
+	return;
+    }
+
+    /* Send initial NOTIFY request */
+    status = pjsip_xfer_send_request( sub, tdata);
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "Unable to send NOTIFY to REFER", status);
+	return;
+    }
+
+    /* We're cheating here.
+     * We need to get a null terminated string from a pj_str_t.
+     * So grab the pointer from the hvalue and NULL terminate it, knowing
+     * that the NULL position will be occupied by a newline. 
      */
-    if (tdata == NULL)
+    uri = refer_to->hvalue.ptr;
+    uri[refer_to->hvalue.slen] = '\0';
+
+    /* Now make the outgoing call. */
+    tmp = pj_str(uri);
+    status = pjsua_call_make_call(existing_call->acc_id, &tmp, 0,
+				  existing_call->user_data, NULL, 
+				  &new_call);
+    if (status != PJ_SUCCESS) {
+
+	/* Notify xferer about the error */
+	status = pjsip_xfer_notify(sub, PJSIP_EVSUB_STATE_TERMINATED,
+				   500, NULL, &tdata);
+	if (status != PJ_SUCCESS) {
+	    pjsua_perror(THIS_FILE, "Unable to create NOTIFY to REFER", 
+			  status);
+	    return;
+	}
+	status = pjsip_xfer_send_request(sub, tdata);
+	if (status != PJ_SUCCESS) {
+	    pjsua_perror(THIS_FILE, "Unable to send NOTIFY to REFER", 
+			  status);
+	    return;
+	}
 	return;
-
-    status = pjsip_inv_send_msg(call->inv, tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, 
-		     "Failed to send end session message", 
-		     status);
-	return;
-    }
-}
-
-
-/*
- * Put call on-Hold.
- */
-PJ_DEF(pj_status_t) pjsua_call_set_hold(int call_index)
-{
-    pjmedia_sdp_session *sdp;
-    pjsua_call *call;
-    pjsip_tx_data *tdata;
-    pj_status_t status;
-
-    call = &pjsua.calls[call_index];
-    
-    if (!call->inv) {
-	PJ_LOG(3,(THIS_FILE,"Call has been disconnected"));
-	return PJSIP_ESESSIONTERMINATED;
-    }
-
-    if (call->inv->state != PJSIP_INV_STATE_CONFIRMED) {
-	PJ_LOG(3,(THIS_FILE, "Can not hold call that is not confirmed"));
-	return PJSIP_ESESSIONSTATE;
-    }
-
-    status = create_inactive_sdp(call, &sdp);
-    if (status != PJ_SUCCESS)
-	return status;
-
-    /* Send re-INVITE with new offer */
-    status = pjsip_inv_reinvite( call->inv, NULL, sdp, &tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create re-INVITE", status);
-	return status;
-    }
-
-    status = pjsip_inv_send_msg( call->inv, tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to send re-INVITE", status);
-	return status;
-    }
-
-    return PJ_SUCCESS;
-}
-
-
-/*
- * re-INVITE.
- */
-PJ_DEF(pj_status_t) pjsua_call_reinvite(int call_index)
-{
-    pjmedia_sdp_session *sdp;
-    pjsip_tx_data *tdata;
-    pjsua_call *call;
-    pj_status_t status;
-
-    call = &pjsua.calls[call_index];
-
-    if (!call->inv) {
-	PJ_LOG(3,(THIS_FILE,"Call has been disconnected"));
-	return PJSIP_ESESSIONTERMINATED;
-    }
-
-
-    if (call->inv->state != PJSIP_INV_STATE_CONFIRMED) {
-	PJ_LOG(3,(THIS_FILE, "Can not re-INVITE call that is not confirmed"));
-	return PJSIP_ESESSIONSTATE;
-    }
-
-    /* Create SDP */
-    status = pjmedia_endpt_create_sdp( pjsua.med_endpt, call->inv->pool, 1,
-				       &call->skinfo, &sdp);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to get SDP from media endpoint", 
-		     status);
-	return status;
-    }
-
-    /* Send re-INVITE with new offer */
-    status = pjsip_inv_reinvite( call->inv, NULL, sdp, &tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create re-INVITE", status);
-	return status;
-    }
-
-    status = pjsip_inv_send_msg( call->inv, tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to send re-INVITE", status);
-	return status;
-    }
-
-    return PJ_SUCCESS;
-}
-
-
-/*
- * Transfer call.
- */
-PJ_DEF(pj_status_t) pjsua_call_xfer(unsigned call_index, const pj_str_t *dest)
-{
-    pjsip_evsub *sub;
-    pjsip_tx_data *tdata;
-    pjsua_call *call;
-    pj_status_t status;
-
-    
-    call = &pjsua.calls[call_index];
-
-    if (!call->inv) {
-	PJ_LOG(3,(THIS_FILE,"Call has been disconnected"));
-	return PJSIP_ESESSIONTERMINATED;
-    }
-   
-    /* Create xfer client subscription.
-     * We're not interested in knowing the transfer result, so we
-     * put NULL as the callback.
+    }
+
+    /* Put the server subscription in inv_data.
+     * Subsequent state changed in pjsua_inv_on_state_changed() will be
+     * reported back to the server subscription.
      */
-    status = pjsip_xfer_create_uac(call->inv->dlg, NULL, &sub);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create xfer", status);
-	return status;
-    }
-
-    /*
-     * Create REFER request.
-     */
-    status = pjsip_xfer_initiate(sub, dest, &tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create REFER request", status);
-	return status;
-    }
-
-    /* Send. */
-    status = pjsip_xfer_send_request(sub, tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to send REFER request", status);
-	return status;
-    }
-
-    /* For simplicity (that's what this program is intended to be!), 
-     * leave the original invite session as it is. More advanced application
-     * may want to hold the INVITE, or terminate the invite, or whatever.
-     */
-
-    return PJ_SUCCESS;
-}
-
-
-/**
- * Dial DTMF.
- */
-PJ_DEF(pj_status_t) pjsua_call_dial_dtmf( unsigned call_index, 
-					  const pj_str_t *digits)
-{
-    pjsua_call *call = &pjsua.calls[call_index];
-
-    PJ_ASSERT_RETURN(call_index < pjsua.config.max_calls, PJ_EINVAL);
-
-    if (!call->session) {
-	PJ_LOG(3,(THIS_FILE, "Media is not established yet!"));
-	return -1;
-    }
-
-    return pjmedia_session_dial_dtmf( call->session, 0, digits);
-}
-
-
-/**
- * Send instant messaging inside INVITE session.
- */
-PJ_DEF(pj_status_t) pjsua_call_send_im(int call_index, const pj_str_t *str)
-{
-    pjsua_call *call;
-    const pj_str_t mime_text = pj_str("text");
-    const pj_str_t mime_plain = pj_str("plain");
-    pjsip_tx_data *tdata;
-    pj_status_t status;
-
-    call = &pjsua.calls[call_index];
-
-    if (!call->inv) {
-	PJ_LOG(3,(THIS_FILE,"Call has been disconnected"));
-	return PJSIP_ESESSIONTERMINATED;
-    }
-
-    /* Lock dialog. */
-    pjsip_dlg_inc_lock(call->inv->dlg);
-    
-    /* Create request message. */
-    status = pjsip_dlg_create_request( call->inv->dlg, &pjsip_message_method,
-				       -1, &tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create MESSAGE request", status);
-	goto on_return;
-    }
-
-    /* Add accept header. */
-    pjsip_msg_add_hdr( tdata->msg, 
-		       (pjsip_hdr*)pjsua_im_create_accept(tdata->pool));
-
-    /* Create "text/plain" message body. */
-    tdata->msg->body = pjsip_msg_body_create( tdata->pool, &mime_text,
-					      &mime_plain, str);
-    if (tdata->msg->body == NULL) {
-	pjsua_perror(THIS_FILE, "Unable to create msg body", PJ_ENOMEM);
-	pjsip_tx_data_dec_ref(tdata);
-	goto on_return;
-    }
-
-    /* Send the request. */
-    status = pjsip_dlg_send_request( call->inv->dlg, tdata, -1, NULL);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to send MESSAGE request", status);
-	goto on_return;
-    }
-
-on_return:
-    pjsip_dlg_dec_lock(call->inv->dlg);
-    return status;
-}
-
-
-/**
- * Send IM typing indication inside INVITE session.
- */
-PJ_DEF(pj_status_t) pjsua_call_send_typing_ind(int call_index, 
-					       pj_bool_t is_typing)
-{
-    pjsua_call *call;
-    pjsip_tx_data *tdata;
-    pj_status_t status;
-
-    call = &pjsua.calls[call_index];
-
-    if (!call->inv) {
-	PJ_LOG(3,(THIS_FILE,"Call has been disconnected"));
-	return PJSIP_ESESSIONTERMINATED;
-    }
-
-    /* Lock dialog. */
-    pjsip_dlg_inc_lock(call->inv->dlg);
-    
-    /* Create request message. */
-    status = pjsip_dlg_create_request( call->inv->dlg, &pjsip_message_method,
-				       -1, &tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create MESSAGE request", status);
-	goto on_return;
-    }
-
-    /* Create "application/im-iscomposing+xml" msg body. */
-    tdata->msg->body = pjsip_iscomposing_create_body(tdata->pool, is_typing,
-						     NULL, NULL, -1);
-
-    /* Send the request. */
-    status = pjsip_dlg_send_request( call->inv->dlg, tdata, -1, NULL);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to send MESSAGE request", status);
-	goto on_return;
-    }
-
-on_return:
-    pjsip_dlg_dec_lock(call->inv->dlg);
-    return status;
-}
-
-
-/*
- * Terminate all calls.
- */
-PJ_DEF(void) pjsua_call_hangup_all(void)
-{
-    unsigned i;
-
-    for (i=0; i<pjsua.config.max_calls; ++i) {
-	pjsip_tx_data *tdata;
-	int st_code;
-	pjsua_call *call;
-
-	if (pjsua.calls[i].inv == NULL)
-	    continue;
-
-	call = &pjsua.calls[i];
-
-	if (call->inv->state == PJSIP_INV_STATE_CONFIRMED) {
-	    st_code = 200;
-	} else {
-	    st_code = PJSIP_SC_GONE;
+    pjsua_var.calls[new_call].xfer_sub = sub;
+
+    /* Put the invite_data in the subscription. */
+    pjsip_evsub_set_mod_data(sub, pjsua_var.mod.id, 
+			     &pjsua_var.calls[new_call]);
+}
+
+
+
+/*
+ * This callback is called when transaction state has changed in INVITE
+ * session. We use this to trap:
+ *  - incoming REFER request.
+ *  - incoming MESSAGE request.
+ */
+static void pjsua_call_on_tsx_state_changed(pjsip_inv_session *inv,
+					    pjsip_transaction *tsx,
+					    pjsip_event *e)
+{
+    pjsua_call *call = inv->dlg->mod_data[pjsua_var.mod.id];
+
+    PJSUA_LOCK();
+
+    if (tsx->role==PJSIP_ROLE_UAS &&
+	tsx->state==PJSIP_TSX_STATE_TRYING &&
+	pjsip_method_cmp(&tsx->method, &pjsip_refer_method)==0)
+    {
+	/*
+	 * Incoming REFER request.
+	 */
+	on_call_transfered(call->inv, e->body.tsx_state.src.rdata);
+
+    }
+    else if (tsx->role==PJSIP_ROLE_UAS &&
+	     tsx->state==PJSIP_TSX_STATE_TRYING &&
+	     pjsip_method_cmp(&tsx->method, &pjsip_message_method)==0)
+    {
+	/*
+	 * Incoming MESSAGE request!
+	 */
+	pjsip_rx_data *rdata;
+	pjsip_msg *msg;
+	pjsip_accept_hdr *accept_hdr;
+	pj_status_t status;
+
+	rdata = e->body.tsx_state.src.rdata;
+	msg = rdata->msg_info.msg;
+
+	/* Request MUST have message body, with Content-Type equal to
+	 * "text/plain".
+	 */
+	if (pjsua_im_accept_pager(rdata, &accept_hdr) == PJ_FALSE) {
+
+	    pjsip_hdr hdr_list;
+
+	    pj_list_init(&hdr_list);
+	    pj_list_push_back(&hdr_list, accept_hdr);
+
+	    pjsip_dlg_respond( inv->dlg, rdata, PJSIP_SC_NOT_ACCEPTABLE_HERE, 
+			       NULL, &hdr_list, NULL );
+	    PJSUA_UNLOCK();
+	    return;
 	}
 
-	if (pjsip_inv_end_session(call->inv, st_code, NULL, &tdata)==0) {
-	    if (tdata)
-		pjsip_inv_send_msg(call->inv, tdata);
+	/* Respond with 200 first, so that remote doesn't retransmit in case
+	 * the UI takes too long to process the message. 
+	 */
+	status = pjsip_dlg_respond( inv->dlg, rdata, 200, NULL, NULL, NULL);
+
+	/* Process MESSAGE request */
+	pjsua_im_process_pager(call->index, &inv->dlg->remote.info_str,
+			       &inv->dlg->local.info_str, rdata);
+
+    }
+    else if (tsx->role == PJSIP_ROLE_UAC &&
+	     pjsip_method_cmp(&tsx->method, &pjsip_message_method)==0)
+    {
+	/* Handle outgoing pager status */
+	if (tsx->status_code >= 200) {
+	    pjsua_im_data *im_data;
+
+	    im_data = tsx->mod_data[pjsua_var.mod.id];
+	    /* im_data can be NULL if this is typing indication */
+
+	    if (im_data && pjsua_var.ua_cfg.cb.on_pager_status) {
+		pjsua_var.ua_cfg.cb.on_pager_status(im_data->call_id,
+						    &im_data->to,
+						    &im_data->body,
+						    im_data->user_data,
+						    tsx->status_code,
+						    &tsx->status_text);
+	    }
 	}
     }
-}
-
-
-pj_status_t pjsua_call_init(void)
-{
-    /* Initialize invite session callback. */
-    pjsip_inv_callback inv_cb;
-    pj_status_t status;
-
-    pj_memset(&inv_cb, 0, sizeof(inv_cb));
-    inv_cb.on_state_changed = &pjsua_call_on_state_changed;
-    inv_cb.on_new_session = &pjsua_call_on_forked;
-    inv_cb.on_media_update = &pjsua_call_on_media_update;
-    inv_cb.on_rx_offer = &pjsua_call_on_rx_offer;
-    inv_cb.on_tsx_state_changed = &pjsua_call_on_tsx_state_changed;
-
-
-    /* Initialize invite session module: */
-    status = pjsip_inv_usage_init(pjsua.endpt, &inv_cb);
-    
-    return status;
-}
-
-/**
- * Replace media transport.
- */
-PJ_DEF(pj_status_t) pjsua_set_call_media_transport( unsigned call_index,
-						    const pjmedia_sock_info *i,
-						    pjmedia_transport *tp)
-{
-    pjsua_call *call = &pjsua.calls[call_index];
-
-    if (i)
-	pj_memcpy(&call->skinfo, i, sizeof(pjmedia_sock_info));
-    
-    if (call->med_tp)
-	(*call->med_tp->op->destroy)(call->med_tp);
-
-    call->med_tp = tp;
-    return PJ_SUCCESS;
-}
+
+
+    PJSUA_UNLOCK();
+}
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 502)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 503)
@@ -18,176 +18,116 @@
  */
 #include <pjsua-lib/pjsua.h>
-#include "pjsua_imp.h"
-
-/*
- * pjsua_core.c
+#include <pjsua-lib/pjsua_internal.h>
+
+
+#define THIS_FILE   "pjsua_core.c"
+
+
+/* PJSUA application instance. */
+struct pjsua_data pjsua_var;
+
+
+/* Display error */
+PJ_DEF(void) pjsua_perror( const char *sender, const char *title, 
+			   pj_status_t status)
+{
+    char errmsg[PJ_ERR_MSG_SIZE];
+
+    pj_strerror(status, errmsg, sizeof(errmsg));
+    PJ_LOG(3,(sender, "%s: %s [status=%d]", title, errmsg, status));
+}
+
+
+static void init_data()
+{
+    unsigned i;
+
+    for (i=0; i<PJ_ARRAY_SIZE(pjsua_var.acc); ++i)
+	pjsua_var.acc[i].index = i;
+    
+    for (i=0; i<PJ_ARRAY_SIZE(pjsua_var.tpdata); ++i)
+	pjsua_var.tpdata[i].index = i;
+}
+
+
+
+/*****************************************************************************
+ * This is a very simple PJSIP module, whose sole purpose is to display
+ * incoming and outgoing messages to log. This module will have priority
+ * higher than transport layer, which means:
  *
- * Core application functionalities.
- */
-
-#define THIS_FILE   "pjsua_core.c"
-
-
-/* 
- * Global variable.
- */
-struct pjsua pjsua;
-
-
-/* 
- * Default local URI, if none is specified in cmd-line 
- */
-#define PJSUA_LOCAL_URI	    "<sip:user@127.0.0.1>"
-
-
-
-/*
- * Init default application parameters.
- */
-PJ_DEF(void) pjsua_default_config(pjsua_config *cfg)
-{
-    unsigned i;
-
-    pj_memset(cfg, 0, sizeof(pjsua_config));
-
-    cfg->thread_cnt = 1;
-    cfg->media_has_ioqueue = 1;
-    cfg->media_thread_cnt = 1;
-    cfg->udp_port = 5060;
-    cfg->start_rtp_port = 4000;
-    cfg->msg_logging = PJ_TRUE;
-    cfg->max_calls = 4;
-    cfg->conf_ports = 0;
-
-#if defined(PJ_DARWINOS) && PJ_DARWINOS!=0
-    pjsua.clock_rate = 44100;
-#endif
-
-    cfg->complexity = 10;
-    cfg->quality = 10;
+ *  - incoming messages will come to this module first before reaching
+ *    transaction layer.
+ *
+ *  - outgoing messages will come to this module last, after the message
+ *    has been 'printed' to contiguous buffer by transport layer and
+ *    appropriate transport instance has been decided for this message.
+ *
+ */
+
+/* Notification on incoming messages */
+static pj_bool_t logging_on_rx_msg(pjsip_rx_data *rdata)
+{
+    PJ_LOG(4,(THIS_FILE, "RX %d bytes %s from %s:%d:\n"
+			 "%s\n"
+			 "--end msg--",
+			 rdata->msg_info.len,
+			 pjsip_rx_data_get_info(rdata),
+			 rdata->pkt_info.src_name,
+			 rdata->pkt_info.src_port,
+			 rdata->msg_info.msg_buf));
     
-    cfg->auto_answer = 100;
-    cfg->uas_duration = 3600;
-
-    /* Default logging settings: */
-    cfg->log_level = 5;
-    cfg->app_log_level = 4;
-    cfg->log_decor =  PJ_LOG_HAS_SENDER | PJ_LOG_HAS_TIME | 
-		      PJ_LOG_HAS_MICRO_SEC | PJ_LOG_HAS_NEWLINE;
-
-
-    /* Also init logging settings in pjsua.config, because log
-     * may be written before pjsua_init() is called.
+    /* Always return false, otherwise messages will not get processed! */
+    return PJ_FALSE;
+}
+
+/* Notification on outgoing messages */
+static pj_status_t logging_on_tx_msg(pjsip_tx_data *tdata)
+{
+    
+    /* Important note:
+     *	tp_info field is only valid after outgoing messages has passed
+     *	transport layer. So don't try to access tp_info when the module
+     *	has lower priority than transport layer.
      */
-    pjsua.config.log_level = 5;
-    pjsua.config.app_log_level = 4;
-
-
-    /* Init accounts: */
-    for (i=0; i<PJ_ARRAY_SIZE(pjsua.acc); ++i) {
-	cfg->acc_config[i].reg_timeout = 55;
-    }
-
-}
-
-
-#define strncpy_with_null(dst,src,len)	\
-do { \
-    strncpy(dst, src, len); \
-    dst[len-1] = '\0'; \
-} while (0)
-
-
-
-PJ_DEF(pj_status_t) pjsua_test_config( const pjsua_config *cfg,
-				       char *errmsg,
-				       int len)
-{
-    unsigned i;
-
-    /* If UDP port is zero, then sip_host and sip_port must be specified */
-    if (cfg->udp_port == 0) {
-	if (cfg->sip_host.slen==0 || cfg->sip_port==0) {
-	    strncpy_with_null(errmsg, 
-			      "sip_host and sip_port must be specified",
-			      len);
-	    return -1;
-	}
-    }
-
-    if (cfg->max_calls < 1) {
-	strncpy_with_null(errmsg, 
-			  "max_calls needs to be at least 1",
-			  len);
-	return -1;
-    }
-
-    /* STUN */
-    if (cfg->stun_srv1.slen || cfg->stun_port1 || cfg->stun_port2 || 
-	cfg->stun_srv2.slen) 
-    {
-	if (cfg->stun_port1 == 0) {
-	    strncpy_with_null(errmsg, "stun_port1 required", len);
-	    return -1;
-	}
-	if (cfg->stun_srv1.slen == 0) {
-	    strncpy_with_null(errmsg, "stun_srv1 required", len);
-	    return -1;
-	}
-	if (cfg->stun_port2 == 0) {
-	    strncpy_with_null(errmsg, "stun_port2 required", len);
-	    return -1;
-	}
-	if (cfg->stun_srv2.slen == 0) {
-	    strncpy_with_null(errmsg, "stun_srv2 required", len);
-	    return -1;
-	}
-    }
-
-    /* Verify accounts */
-    for (i=0; i<cfg->acc_cnt; ++i) {
-	const pjsua_acc_config *acc_cfg = &cfg->acc_config[i];
-	unsigned j;
-
-	if (acc_cfg->id.slen == 0) {
-	    strncpy_with_null(errmsg, "missing account ID", len);
-	    return -1;
-	}
-
-	if (acc_cfg->id.slen == 0) {
-	    strncpy_with_null(errmsg, "missing registrar URI", len);
-	    return -1;
-	}
-
-	if (acc_cfg->reg_timeout == 0) {
-	    strncpy_with_null(errmsg, "missing registration timeout", len);
-	    return -1;
-	}
-
-
-	for (j=0; j<acc_cfg->cred_count; ++j) {
-
-	    if (acc_cfg->cred_info[j].scheme.slen == 0) {
-		strncpy_with_null(errmsg, "missing auth scheme in account", 
-				  len);
-		return -1;
-	    }
-
-	    if (acc_cfg->cred_info[j].realm.slen == 0) {
-		strncpy_with_null(errmsg, "missing realm in account", len);
-		return -1;
-	    }
-
-	    if (acc_cfg->cred_info[j].username.slen == 0) {
-		strncpy_with_null(errmsg, "missing username in account", len);
-		return -1;
-	    }
-
-	}
-    }
-
+
+    PJ_LOG(4,(THIS_FILE, "TX %d bytes %s to %s:%d:\n"
+			 "%s\n"
+			 "--end msg--",
+			 (tdata->buf.cur - tdata->buf.start),
+			 pjsip_tx_data_get_info(tdata),
+			 tdata->tp_info.dst_name,
+			 tdata->tp_info.dst_port,
+			 tdata->buf.start));
+
+    /* Always return success, otherwise message will not get sent! */
     return PJ_SUCCESS;
 }
 
+/* The module instance. */
+static pjsip_module pjsua_msg_logger = 
+{
+    NULL, NULL,				/* prev, next.		*/
+    { "mod-pjsua-log", 13 },		/* Name.		*/
+    -1,					/* Id			*/
+    PJSIP_MOD_PRIORITY_TRANSPORT_LAYER-1,/* Priority	        */
+    NULL,				/* load()		*/
+    NULL,				/* start()		*/
+    NULL,				/* stop()		*/
+    NULL,				/* unload()		*/
+    &logging_on_rx_msg,			/* on_rx_request()	*/
+    &logging_on_rx_msg,			/* on_rx_response()	*/
+    &logging_on_tx_msg,			/* on_tx_request.	*/
+    &logging_on_tx_msg,			/* on_tx_response()	*/
+    NULL,				/* on_tsx_state()	*/
+
+};
+
+
+/*****************************************************************************
+ * These two functions are the main callbacks registered to PJSIP stack
+ * to receive SIP request and response messages that are outside any
+ * dialogs and any transactions.
+ */
 
 /*
@@ -202,11 +142,16 @@
 static pj_bool_t mod_pjsua_on_rx_request(pjsip_rx_data *rdata)
 {
+    pj_bool_t processed = PJ_FALSE;
+
+    PJSUA_LOCK();
 
     if (rdata->msg_info.msg->line.req.method.id == PJSIP_INVITE_METHOD) {
 
-	return pjsua_call_on_incoming(rdata);
-    }
-
-    return PJ_FALSE;
+	processed = pjsua_call_on_incoming(rdata);
+    }
+
+    PJSUA_UNLOCK();
+
+    return processed;
 }
 
